/*
    ES Knot
    Copyright 2005, 2006 Martin Storsj

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Martin Storsj
    martin@martin.st
*/

#ifndef __KNOTAPPVIEW_H
#define __KNOTAPPVIEW_H

#include <coecntrl.h>
#include <gles/egl.h>
#include "glappview.h"

class Knot;

class CKnotAppView : public CGLAppView {
public:

	static CKnotAppView* NewL(const TRect& aRect);
	static CKnotAppView* NewLC(const TRect& aRect);
	~CKnotAppView();

	TKeyResponse OfferKeyEventL(const TKeyEvent& aKeyEvent, TEventCode aType);

	void SizeChanged();

protected:
	void DeinitGC();
	void InitGC();
	void ConstructAppL();
	void ReinitApp();
	void UpdateAndDraw();
	void FPSUpdated();

private:
	CKnotAppView();

	const CFont* iFont;

public:
	Knot* iKnot;
};

#endif
